/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest{}

// PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest struct for PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest
type PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest struct {
	LiveFrom *string `json:"live_from,omitempty"`
	LiveTo *string `json:"live_to,omitempty"`
	// This value is optional
	ChannelIds []string `json:"channel_ids,omitempty"`
	// For global rollout, list of orgs and channels where rollout will be scheduled
	Organizations []PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner `json:"organizations,omitempty"`
}

// NewPostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest instantiates a new PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest() *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest {
	this := PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest{}
	return &this
}

// NewPostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestWithDefaults instantiates a new PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestWithDefaults() *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest {
	this := PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest{}
	return &this
}

// GetLiveFrom returns the LiveFrom field value if set, zero value otherwise.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) GetLiveFrom() string {
	if o == nil || IsNil(o.LiveFrom) {
		var ret string
		return ret
	}
	return *o.LiveFrom
}

// GetLiveFromOk returns a tuple with the LiveFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) GetLiveFromOk() (*string, bool) {
	if o == nil || IsNil(o.LiveFrom) {
		return nil, false
	}
	return o.LiveFrom, true
}

// HasLiveFrom returns a boolean if a field has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) HasLiveFrom() bool {
	if o != nil && !IsNil(o.LiveFrom) {
		return true
	}

	return false
}

// SetLiveFrom gets a reference to the given string and assigns it to the LiveFrom field.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) SetLiveFrom(v string) {
	o.LiveFrom = &v
}

// GetLiveTo returns the LiveTo field value if set, zero value otherwise.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) GetLiveTo() string {
	if o == nil || IsNil(o.LiveTo) {
		var ret string
		return ret
	}
	return *o.LiveTo
}

// GetLiveToOk returns a tuple with the LiveTo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) GetLiveToOk() (*string, bool) {
	if o == nil || IsNil(o.LiveTo) {
		return nil, false
	}
	return o.LiveTo, true
}

// HasLiveTo returns a boolean if a field has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) HasLiveTo() bool {
	if o != nil && !IsNil(o.LiveTo) {
		return true
	}

	return false
}

// SetLiveTo gets a reference to the given string and assigns it to the LiveTo field.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) SetLiveTo(v string) {
	o.LiveTo = &v
}

// GetChannelIds returns the ChannelIds field value if set, zero value otherwise.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) GetChannelIds() []string {
	if o == nil || IsNil(o.ChannelIds) {
		var ret []string
		return ret
	}
	return o.ChannelIds
}

// GetChannelIdsOk returns a tuple with the ChannelIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) GetChannelIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.ChannelIds) {
		return nil, false
	}
	return o.ChannelIds, true
}

// HasChannelIds returns a boolean if a field has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) HasChannelIds() bool {
	if o != nil && !IsNil(o.ChannelIds) {
		return true
	}

	return false
}

// SetChannelIds gets a reference to the given []string and assigns it to the ChannelIds field.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) SetChannelIds(v []string) {
	o.ChannelIds = v
}

// GetOrganizations returns the Organizations field value if set, zero value otherwise.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) GetOrganizations() []PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner {
	if o == nil || IsNil(o.Organizations) {
		var ret []PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner
		return ret
	}
	return o.Organizations
}

// GetOrganizationsOk returns a tuple with the Organizations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) GetOrganizationsOk() ([]PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner, bool) {
	if o == nil || IsNil(o.Organizations) {
		return nil, false
	}
	return o.Organizations, true
}

// HasOrganizations returns a boolean if a field has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) HasOrganizations() bool {
	if o != nil && !IsNil(o.Organizations) {
		return true
	}

	return false
}

// SetOrganizations gets a reference to the given []PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner and assigns it to the Organizations field.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) SetOrganizations(v []PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) {
	o.Organizations = v
}

func (o PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.LiveFrom) {
		toSerialize["live_from"] = o.LiveFrom
	}
	if !IsNil(o.LiveTo) {
		toSerialize["live_to"] = o.LiveTo
	}
	if !IsNil(o.ChannelIds) {
		toSerialize["channel_ids"] = o.ChannelIds
	}
	if !IsNil(o.Organizations) {
		toSerialize["organizations"] = o.Organizations
	}
	return toSerialize, nil
}

type NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest struct {
	value *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest
	isSet bool
}

func (v NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) Get() *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest {
	return v.value
}

func (v *NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) Set(val *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest(val *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) *NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest {
	return &NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest{value: val, isSet: true}
}

func (v NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


